// ArgusGUIDlg.cpp : implementation file
//


#include "stdafx.h"
#include "resource.h"

#include "argus_api.h"

#include "ArgusGUI.h"
#include "ArgusGUIDlg.h"
#include "ArgusGUIProgressDialog.h"
#include "CropDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArgusGUIDlg dialog

CArgusGUIDlg::CArgusGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArgusGUIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CArgusGUIDlg)
	m_cfgName = _T("");
	m_folderName = _T("");
	m_PDFName = _T("");
	m_pageFrom = 1;
	m_pageTo = 1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArgusGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CArgusGUIDlg)
	DDX_Text(pDX, IDC_CFG, m_cfgName);
	DDX_Text(pDX, IDC_FOLDER, m_folderName);
	DDX_Text(pDX, IDC_PASSWORD, m_password);
	DDX_Text(pDX, IDC_PDF, m_PDFName);
	DDX_Text(pDX, IDC_PAGE_FROM, m_pageFrom);
	DDX_Text(pDX, IDC_PAGE_TO, m_pageTo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CArgusGUIDlg, CDialog)
	//{{AFX_MSG_MAP(CArgusGUIDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CFG_BROWSE, OnCfgBrowse)
	ON_BN_CLICKED(IDC_BUTTON_FOLDER_BROWSE, OnFolderBrowse)
	ON_BN_CLICKED(IDC_BUTTON_PDF_BROWSE, OnPdfBrowse)
	ON_BN_CLICKED(ID_BUTTON_CROP, OnCrop)
	ON_BN_CLICKED(IDOK, OnProcess)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArgusGUIDlg message handlers

BOOL CArgusGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CEdit* CFGEdit = (CEdit*)GetDlgItem(IDC_CFG);
	CEdit* folderEdit = (CEdit*)GetDlgItem(IDC_FOLDER);
	CEdit* PDFEdit = (CEdit*)GetDlgItem(IDC_PDF);

	CFGEdit->SetWindowText("exampleGUI-html.cfg");
	PDFEdit->SetWindowText("romeo.pdf");
	folderEdit->SetWindowText(".\\output");

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CArgusGUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArgusGUIDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArgusGUIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CArgusGUIDlg::OnCrop() 
{
	CCropDialog cropDlg;

	/* Get the values from the dialog set by the user */
	UpdateData(TRUE);
	theApp.cropFileName = (char*)((const char*)(m_PDFName));

	/* Create and display the cropping dialog. This is a modal dialog */
	if (cropDlg.DoModal() == IDOK)
	{
		/* Describe the cropping box just set up */
		CStatic* text = (CStatic*)GetDlgItem(IDC_CROP_TEXT);
		
		sprintf(cropText, "left:%.1f top:%.1f right:%.1f bott:%.1f", 
			theApp.cropBox.left, theApp.cropBox.top, theApp.cropBox.right, theApp.cropBox.bottom);
	
		text->SetWindowText(cropText);
		haveCropBox = TRUE;
	}
}

void CArgusGUIDlg::OnCfgBrowse() 
{
	CString title;

	/* Make filter for open dialog */
	CString filter = "Argus Configuration files (*.cfg)|*.cfg||";
	CEdit* CFGEdit = (CEdit*)GetDlgItem(IDC_CFG);

	CFileDialog openDialog(TRUE, ".cfg", NULL,  
					   OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT,
					   filter);

	title.LoadString(IDS_OPENCFG);
	openDialog.m_ofn.lpstrTitle = title;

	if(openDialog.DoModal() == IDOK)
	{
		m_cfgName = openDialog.GetPathName();
		
		CFGEdit->SetWindowText(m_cfgName);
	}
	
}

void CArgusGUIDlg::OnFolderBrowse() 
{
	
	// TODO: Add your control notification handler code here
	
	/* Select a destination folder */
	CString folder;
	CEdit* folderEdit = (CEdit*)GetDlgItem(IDC_FOLDER);

	/* Look in ArgusGUIUtils for description of GetFolder */
	if(GetFolder(AfxGetMainWnd()->m_hWnd, NULL, IDS_EXPORTFOLDER, folder))
	{
		m_folderName = folder;
		folderEdit->SetWindowText(folder);
	}
}

void CArgusGUIDlg::OnPdfBrowse() 
{
	CString title;

	/* Make filter for open dialog */
	CString filter = "Acrobat (*.pdf)|*.pdf||";
	CEdit* PDFEdit = (CEdit*)GetDlgItem(IDC_PDF);

	CFileDialog openDialog(TRUE, ".pdf", NULL,  
					   OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT,
					   filter);

	title.LoadString(IDS_OPENPDF);
	openDialog.m_ofn.lpstrTitle = title;

	if(openDialog.DoModal() == IDOK)
	{
		m_PDFName = openDialog.GetPathName();
		
		PDFEdit->SetWindowText(m_PDFName);

		/* Reset the crop box for this new file */
		haveCropBox = FALSE;
		CStatic* text = (CStatic*)GetDlgItem(IDC_CROP_TEXT);
		text->SetWindowText("None");
	}
}

void CArgusGUIDlg::OnProcess() 
{
	void* argusEngine;
	char* configFileName;
	char* pdfFileName;
	char* folderName;
	char* fileList[1];
	char* password;
	int ret;
	CString message, caption;
	CArgusGUIProgressDialog progDialog;

	/* Get the values from the dialog set by the user */
	UpdateData(TRUE);
	configFileName = (char*)((const char*)(m_cfgName));
	pdfFileName = (char*)((const char*)(m_PDFName));
	fileList[0] = pdfFileName;
	folderName = (char*)((const char*)(m_folderName));
	password = (char*)((const char*)(m_password));

	/* Initialise the argus engine */
	argusEngine = icnArgusCreate();
	if (argusEngine == NULL)
	{
		displayError(icnErrorGetCode(), icnErrorGetText());
		icnArgusDestroy(argusEngine);
		return;
	}
	
	/* load the config named */
	if (icnArgusLoadConfigs(argusEngine, configFileName) != 0)
	{
		displayError(icnErrorGetCode(), icnErrorGetText());
		icnArgusDestroy(argusEngine);
		return;
	}

	/* Add a value for the path to Argus which will be expanded as a macro in the
		config file being used */
	ret = icnArgusValueAdd(argusEngine, "path", folderName);
	if (ret != 0)
	{
		displayError(ret, icnErrorGetText());
		icnArgusDestroy(argusEngine);
		return;
	}

	/* Add a value for the image name to Argus which will be expanded as a macro in the
		config file being used */
	ret = icnArgusValueAdd(argusEngine, "imname", "image[PAGENUM]-[PIC_NUM]");
	if (ret != 0)
	{
		displayError(ret, icnErrorGetText());
		icnArgusDestroy(argusEngine);
		return;
	}

	/* Iif the user has specified a crop box for the document... */
	if (haveCropBox)
	{
		/* Add the crop box annot to every (1-#) page in the document */
		icnArgusAddUserAnnot(argusEngine, kCropUserAnnot, "1-#", &theApp.cropBox);
	}

	/* Set up the progress call back functions */
	/* guiMessage will be passed a message along with a level of message */
	/* guiGauge will be passed a percentage indicating progress */
	/* fourth param can be ptr to private data that is passed back to each
	of the progress functions. In this case the a ptr to dialog class that
	displays the progress is used */
	icnArgusSetProgress(argusEngine, guiMessage, guiGauge, guiCancel, &progDialog);

	/* Create and display the progress dialog. This is a modeless dialog */
	progDialog.Create(IDD_PROGRESS);
	progDialog.ShowWindow(SW_SHOWNORMAL);

	/* use any password supplied (its optional). It will only be used
		by the pdf engine when a document requires a password */
	ipSetUserPassword(password, strlen(password));

	/* Perform the extraction */
	ret = icnArgusExtract(argusEngine, fileList, 1, m_pageFrom, m_pageTo);
	if (ret != 0)
	{
		displayError(ret, icnErrorGetText());
		progDialog.DestroyWindow();
		icnArgusDestroy(argusEngine);
		return;
	}

	/* Close the progress dialog */
	progDialog.DestroyWindow();

	/* Shut down the argus engine */
	icnArgusDestroy(argusEngine);

	/* Display message saying processing has completed */
	message.Format("Processing complete");
	caption.LoadString(IDS_ARGUSGUICAPTION);
	MessageBox(message, caption, MB_OK | MB_ICONEXCLAMATION);
}

