Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Module ProgressCallbacks

    Sub progMsg(ByVal level As Integer, <MarshalAs(UnmanagedType.BStr)> text As String)
        ' Displays the text of the progMsgTxt buffer on the
        ' main form. The level indicates the importance of
        ' the message.
        If level < 1 Then
            VBArgus.VersionMessage.Text = text
            VBArgus.VersionMessage.Refresh()
        Else
            VBArgus.lowPriorityInfo.Text = text
            VBArgus.lowPriorityInfo.Refresh()
        End If
    End Sub

    Sub progGauge(ByVal percent As Integer)
        ' This draws a simple fuel gauge based on the percentage
        ' complete value returned by Argus SDK
        'UPGRADE_NOTE: step was upgraded to step_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
        Dim step_Renamed As Single

        step_Renamed = VB6.PixelsToTwipsX(VBArgus.VersionMessage.Width) / 100

        VBArgus.fuelGauge.Width = VB6.TwipsToPixelsX(step_Renamed * percent)
        VBArgus.fuelGauge.Refresh()
    End Sub

    Function progCancel() As Integer
        ' Returning 1 here will cause the SDK to stop processing
        progCancel = 0
    End Function
End Module