Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Module ArgusSDK
    ' Argus SDK 3.2.1
    ' Visual Basic Declarations
    ' (C) 2001 Iceni Technology Ltd
    '
    ' Include this module in your own VB applications in order to call Argus SDK functions

    ' Min. length of version string buffer you should supply
    Const kMaxVersion As Short = 100

    ' Different types of annotation you can add to a page
    Const kTableUserAnnot As Short = 1
    Const kImageUserAnnot As Short = 2
    Const kCropUserAnnot As Short = 3

    ' Describes the location of an annotation on the page
    Structure IPRect
        Dim top As Single
        'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
        Dim left_Renamed As Single
        Dim bottom As Single
        'UPGRADE_NOTE: right was upgraded to right_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
        Dim right_Renamed As Single
    End Structure

    ' --------------------------------------------------------------------------
    ' Getting version information about the SDK
    Declare Function icnArgusGetVersion Lib "Argus.dll" Alias "_icnArgusGetVersionVB@4" (ByVal message As String) As Short

    ' Start the engine
    Declare Function icnArgusCreate Lib "Argus.dll" Alias "_icnArgusCreateVB@0" () As Integer

    ' Load a configuration to tell the SDK how to process documents
    Declare Function icnArgusLoadConfig Lib "Argus.dll" Alias "_icnArgusLoadConfigsVB@8" (ByVal vargus As Integer, ByVal filename As String) As Short

    ' Init the progress callbacks and a ptr to private data of your own */
    Delegate Sub ICNProgMsg(ByVal level As Integer, <MarshalAs(UnmanagedType.BStr)> text As String)
    Delegate Sub ICNProgGauge(ByVal percent As Integer)
    Delegate Function ICNProgCancel() As Integer

    Declare Sub icnArgusSetProgress Lib "Argus.dll" Alias "_icnArgusSetProgressVB@16" (ByVal va As Integer, ByVal lVal As ICNProgMsg, ByVal lVal As ICNProgGauge, ByVal lVal As ICNProgCancel)

    ' This may be called numerous times for each file you need to process
    ' Any output (text or images) is written to disc
    Declare Function icnArgusExtract Lib "Argus.dll" Alias "_icnArgusExtractVB@16" (ByVal va As Integer, ByVal filename As String, ByVal startPage As Integer, ByVal endPage As Integer) As Short

    ' Stop the engine
    Declare Sub icnArgusDestroy Lib "Argus.dll" Alias "_icnArgusDestroyVB@4" (ByVal va As Integer)


    ' --------------------------------------------------------------------------
    ' Adding user-specified annotations - table, image & crop
    'UPGRADE_WARNING: Structure IPRect may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function icnArgusAddUserAnnot Lib "Argus.dll" Alias "_icnArgusAddUserAnnotVB@16" (ByVal va As Integer, ByVal annotType As Byte, ByVal rangeStr As String, ByRef bbox As IPRect) As Short

    ' Add your own macro keys for the VALUE macro. Useful for customising
    ' configuration files on the fly.
    Declare Function icnArgusValueAdd Lib "Argus.dll" Alias "_icnArgusValueAddVB@12" (ByVal va As Integer, ByVal key As String, ByVal value As String) As Short


    ' -- Memory Extraction API -------------------------------------------------

    ' Load a document into the SDK ready for processing
    Declare Function icnArgusDocCreate Lib "Argus.dll" Alias "_icnArgusDocCreateVB@8" (ByVal va As Integer, ByVal filename As String) As Integer

    ' Analyse specific pages of the document. Must do this before extracting text from it
    Declare Function icnArgusDocAnalyse Lib "Argus.dll" Alias "_icnArgusDocAnalyseVB@16" (ByVal va As Integer, ByVal doc As Integer, ByVal startPage As Integer, ByVal endPage As Integer) As Short

    ' Get text from a page of the document. Returned string could be big
    Declare Function icnArgusDocGetText Lib "Argus.dll" Alias "_icnArgusDocGetiTextVB@12" (ByVal va As Integer, ByVal doc As Integer, ByVal pageNum As Integer) As String

    ' Get nof pages in the document
    Declare Function icnDocGetPageCount Lib "Argus.dll" Alias "_icnDocGetPageCountVB@4" (ByVal doc As Integer) As Short

    ' Destroy the loaded document. You must call once finished with it.
    Declare Sub icnDocDestroy Lib "Argus.dll" Alias "_icnDocDestroyVB@4" (ByVal doc As Integer)

    ' Use this to free up text (or memory) allocated by the SDK.
    Declare Sub icnDestroyText Lib "Argus.dll" Alias "_icnDestroyTextVB@4" (ByVal filename As String)


    ' -- Getting Error Information ---------------------------------------------

    ' Returns detail text of error messages
    Declare Function icnErrorGetText Lib "Argus.dll" Alias "_icnErrorGetTextVB@8" (ByVal errorText As String, ByVal buffLen As Integer) As Short

    ' Returns standard description of error code
    Declare Function icnErrorGetStdText Lib "Argus.dll" Alias "_icnErrorGetStdTextVB@8" (ByVal errorText As String, ByVal buffLen As Integer) As Short

    ' Returns just the error number of the last error
    Declare Function icnErrorGetCode Lib "Argus.dll" Alias "_icnArgusGetCodeVB@0" () As Short


    ' -- Accessing pdf interpreter directly ------------------------------------

    ' set a password used to open all following documents that require one
    Declare Sub ipSetUserPassword Lib "Argus.dll" Alias "_ipSetUserPasswordVB@4" (ByVal message As String)
End Module