/* 

	Abstract data type definitions. Used by both ipd.h and ipdPublic.h
*/

#ifndef _IPD_ABSTRACT_
#define _IPD_ABSTRACT_

	typedef struct AB_DOC*				IPVDoc;
	typedef struct AB_PAGE*				IPVPage;
	typedef struct AB_TEXT*				IPVText;
	typedef struct AB_PATH*				IPVPath;
	typedef struct AB_IMAGE*			IPVImage;
	typedef struct AB_FONT*				IPVFont;
	typedef struct AB_RAWFONT*			IPVRawFont;
	typedef struct AB_VIS*				IPVisual;

	typedef struct AB_OBJ*				IPVTag;
	typedef struct AB_OBJ*				IPVTagElem;
	typedef struct AB_OBJ*				IPVObj;
	typedef struct AB_OBJ*				IPVThread;

	typedef struct AB_DICT*				IPVDict;
	typedef struct AB_NAME*				IPVName;
	typedef struct AB_ARRAY*			IPVArray;
	typedef struct AB_STREAM*			IPVStream;
	typedef struct AB_MATHFUNC*		IPVMathFunc;
	typedef struct AB_TAGINFO*			IPVTagInfo;

	typedef struct AB_SERIAL*			IPVSerial;

/* -------------------------------------------------------------------------- */
typedef struct
{
	float h; /* x */
	float v; /* y */
} IPPoint;

typedef struct	IP_RECT	
{
	/* Describes a non-rotated rectangle */
	float top;	
	float left;
	float bottom;
	float right;
} IPRect;

typedef struct		/* Needed to describe a rectangle at an angle */
{
	IPPoint bl;		/* bottom-left  */
	IPPoint tl;		/* top-left     */
	IPPoint tr;		/* top-right    */
	IPPoint br;		/* bottom-right */
} IPQuad;

typedef struct	IP_MATRIX
{ 
	float a;
	float b;
	float c;
	float d;
	float h;
	float v;
} IPMatrix;
#endif /* _IPD_ABSTRACT_ */

